<script>
    import { layout } from "../svelte_stores/layout_store";

    import {
        Table,
        TableHead,
        TableHeadCell,
        TableBody,
        TableBodyCell,
        TableBodyRow,
    } from "flowbite-svelte";
    import {
        Label,
        Input,
        NumberInput,
        Toggle,
        Select,
        Helper,
    } from "flowbite-svelte";

    import RangeWithNumberInput from "../form_components/RangeWithNumberInput.svelte";

    import { timeDomain } from "../svelte_stores/timedomain_store";
    import {
        global_zoom_detail_factor,
        range_pixels,
    } from "../svelte_stores/zoom_range_store";

    import {
        find_alternatives,
        select_dataset_from_cadence_info,
    } from "../svelte_stores/alternative_datasets";

    import * as d3 from "d3";

    import dayjs from "dayjs";
    import duration from "dayjs/plugin/duration";
    import relativeTime from "dayjs/plugin/relativeTime";
    dayjs.extend(duration);
    dayjs.extend(relativeTime);

    export let i_subplot;
    export let i_plot_element;
    export let info_query;
    export let catalog_query;

    let date_relative = false;

    let start_date_display = "Not available";

    const date_display = function (date, date_relative) {
        if (date) {
            return date_relative
                ? dayjs(date).fromNow()
                : dayjs(date).toISOString();
        } else {
            return "Unavailable";
        }
    };

    let subplot, plot_element, max_points;
    let alternative_datasets, selected_dataset;

    $: {
        if ($layout.subplots[i_subplot]) {
            subplot = $layout.subplots[i_subplot];
            if ($layout.subplots[i_subplot].plot_elements[i_plot_element]) {
                plot_element = subplot.plot_elements[i_plot_element];
                max_points =
                    $global_zoom_detail_factor *
                    plot_element.data.zoom_detail_factor *
                    $range_pixels;
                alternative_datasets = find_alternatives(
                    plot_element,
                    catalog_query.data,
                    info_query.data,
                );
                selected_dataset = select_dataset_from_cadence_info(
                    alternative_datasets,
                    $timeDomain,
                    max_points,
                );
            }
        }
    }

    const mode_titles = {
        off: "Off - use only this dataset",
        knmi: "KNMI - ISO duration after last underscore",
        x_relations:
            "KNMI - Use of x_relations with different cadences in main dataset's HAPI info",
        intermagnet:
            "Intermagnet - ISO duration between last two forward-slashes",
        // manual: "Manual - create links to other plot elements in this subplot (not yet implemented)",
    };

    $: cadence =
        $layout.subplots[i_subplot].plot_elements[i_plot_element].cadence;
    let validCadence = false;
    $: cadenceDuration = dayjs.duration(cadence);
    $: validCadence = cadenceDuration > 0 && "days" in cadenceDuration.$d;
    $: viewport_duration = dayjs.duration($timeDomain[1] - $timeDomain[0]);
</script>

<Label
    >Dataset cadence selection mode:
    <Select
        bind:value={$layout.subplots[i_subplot].plot_elements[i_plot_element]
            .data.cadence_alternative_datasets_mode}>
        {#each Object.keys(mode_titles) as mode_title_key}
            <option value={mode_title_key}
                >{mode_titles[mode_title_key]}</option>
        {/each}
    </Select>
    <Helper>Use datasets with different cadences on zoom.</Helper>
</Label>

{#if alternative_datasets.length > 0}
    {#if plot_element.data.cadence_alternative_datasets_mode == "knmi" || plot_element.data.cadence_alternative_datasets_mode == "intermagnet" || plot_element.data.cadence_alternative_datasets_mode == "x_relations"}
        <Table>
            <TableHead>
                <TableHeadCell>Dataset ID</TableHeadCell>
                <TableHeadCell>Points</TableHeadCell>
            </TableHead>
            <TableBody>
                {#each alternative_datasets.sort( (a, b) => (a.cadence_info.cadence_sec > b.cadence_info.cadence_sec ? 1 : -1), ) as dataset}
                    <TableBodyRow>
                        <TableBodyCell>
                            {#if selected_dataset.dataset_id == dataset.dataset_id}
                                <span class="text-sky-700 text"
                                    >{dataset.dataset_id}</span>
                            {:else}
                                <span>{dataset.dataset_id}</span>
                            {/if}
                        </TableBodyCell>
                        <TableBodyCell>
                            {d3.format("d")(
                                ($timeDomain[1] - $timeDomain[0]) /
                                    (dataset.cadence_info.cadence_sec * 1000),
                            )}
                        </TableBodyCell>
                    </TableBodyRow>
                {/each}
            </TableBody>
        </Table>
    {:else if plot_element.data.cadence_alternative_datasets_mode == "off"}
        <Helper
            >No alternative datasets. Only this dataset will be used.</Helper>
    {:else}
        <Helper>This mode has not yet been implemented.</Helper>
    {/if}
{/if}

<h2>Timing from HAPI dataset info:</h2>
<Table>
    <TableBody>
        <TableBodyRow>
            <TableBodyCell>Dataset start</TableBodyCell>
            <TableBodyCell>
                {date_display(info_query.data.startDate, date_relative)}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell>Dataset stop</TableBodyCell>
            <TableBodyCell>
                {date_display(info_query.data.stopDate, date_relative)}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell
                >Nominal cadence<Helper>from HAPI info</Helper></TableBodyCell>
            <TableBodyCell>
                {info_query.isSuccess && info_query.data.cadence
                    ? info_query.data.cadence
                    : "Not available"}
            </TableBodyCell>
        </TableBodyRow>
        {#if !info_query.data.cadence}
            <TableBodyRow>
                <TableBodyCell
                    >Override cadence<Helper>ISO 8601 duration string</Helper
                    ></TableBodyCell>
                <TableBodyCell>
                    <Input
                        size="sm"
                        color={validCadence ? "black" : "red"}
                        bind:value={$layout.subplots[i_subplot].plot_elements[
                            i_plot_element
                        ].cadence}></Input>
                    {#if !validCadence}
                        <Helper color="red"
                            >Not a valid positive ISO cadence.</Helper>
                    {/if}
                </TableBodyCell>
            </TableBodyRow>
        {/if}
    </TableBody>
</Table>

<h2>Timing from viewport:</h2>
<Table>
    <TableBody>
        <TableBodyRow>
            <TableBodyCell>Viewport start</TableBodyCell>
            <TableBodyCell>
                {date_display($timeDomain[0], date_relative)}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell>Viewport stop</TableBodyCell>
            <TableBodyCell>
                {date_display($timeDomain[1], date_relative)}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell
                >Viewport duration<Helper>ISO 8601 duration</Helper
                ></TableBodyCell>
            <TableBodyCell>
                {viewport_duration.toISOString()}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell>Plot width in pixels</TableBodyCell>
            <TableBodyCell>
                {$range_pixels}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell>Points at nominal cadence</TableBodyCell>
            <TableBodyCell>
                {info_query.data.cadence
                    ? d3.format("d")(
                          ($timeDomain[1] - $timeDomain[0]) /
                              dayjs
                                  .duration(info_query.data.cadence)
                                  .asMilliseconds(),
                      )
                    : d3.format("d")(
                          ($timeDomain[1] - $timeDomain[0]) /
                              dayjs
                                  .duration(
                                      $layout.subplots[i_subplot].plot_elements[
                                          i_plot_element
                                      ].cadence,
                                  )
                                  .asMilliseconds(),
                      )}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell
                >Zoom detail factors<Helper>global * element</Helper
                ></TableBodyCell>
            <TableBodyCell>
                {$global_zoom_detail_factor} * {$layout.subplots[i_subplot]
                    .plot_elements[i_plot_element].data.zoom_detail_factor} = {$global_zoom_detail_factor *
                    $layout.subplots[i_subplot].plot_elements[i_plot_element]
                        .data.zoom_detail_factor}
            </TableBodyCell>
        </TableBodyRow>
        <TableBodyRow>
            <TableBodyCell
                >Max rows<Helper>per data request</Helper></TableBodyCell>
            <TableBodyCell>
                {max_points}
            </TableBodyCell>
        </TableBodyRow>
    </TableBody>
</Table>
<Toggle size="small" bind:checked={date_relative}
    >Show relative start/stop dates</Toggle>
